package com.nisum;

import java.util.*;
import java.util.stream.Collector;
import java.util.stream.Collectors;
import java.util.stream.Stream;
import java.util.stream.StreamSupport;

import static java.util.stream.Collectors.toCollection;



public class WhoIsTheBest {

    private List<String> theGreats;
    private List<String> theNotSoGreats;
    
    public WhoIsTheBest(){
        this.theGreats = Arrays.asList("Alex P", "Alex S", "Ben", "Chef", "Chris", "Darrick",
                "Deep", "Joe", "John", "Julius", "Kevin", "Khai", "Kyle",
                "Nikitha", "Philippe", "Shanelle", "Sumaiyya", "Vishal");
        this.theNotSoGreats = Arrays.asList("Eric");
    }

    public List<String> getTheGreats() {
        return theGreats;
    }

    public List<String> getTheNotSoGreats() {
        return theNotSoGreats;
    }
    
    public Optional<String> gimmeAGreat(){
        return theGreats.stream().collect(toShuffledStream()).findAny();
    }

    public Optional<String> gimmeANotSoGreat(){
        return theNotSoGreats.stream().findAny();
    }

    public static <T> Collector<T, ?, Stream<T>> toShuffledStream() {
        return Collectors.collectingAndThen(
                toCollection(ArrayList::new),
                list -> !list.isEmpty()
                        ? StreamSupport.stream(new ImprovedRandomSpliterator<>(list, Random::new), false)
                        : Stream.empty());
    };

};

